/* ChiRK 1.2a  (c) 1992 Bo Yang                                           */

#include "chirk.h"

#include <file.h>
#include <string.h>

extern BOOL     big5;
extern BOOL     autowrap;
extern BOOL     eightypl;
extern BOOL     bitmapfont;
extern BOOL     highfont;
extern BOOL     interactive;
extern BOOL	genuine4010;

extern char    *clearstr;
extern void     (*outchar) ();
extern FILE    *fp;
extern unsigned int fx, fy;
extern int      pagenum;
extern int	HZon, zWon;

unsigned int    Yp = Lheight;
unsigned int    Xp = 0;
int             lcwidth, cwidth = 80;
int             cheight;
int             lfheight;
unsigned  char  GBmode=0;

void 
dummy(len, code)		/* do nothing, use with page counting   */
      int             len, code;
{
}

/* clear screen and display page number and the help at the bottom  */

void 
newpage(page)
      int             page;
{
      int             org_80;
      unsigned char   org_GBmode;

      if (page == 0) {
	    outchar = dummy;	/* page==0: Do not write on screen;  */
	    return;		/* Count the Pages only;    */
      }
      if (bitmapfont)
	    outchar = outcharB;
      else
	    outchar = outcharV;
      fputs(clearstr, fp);
      if( genuine4010) {
            fflush(fp);
	    sleep(2);
	    }
     fx = (fy = 0);
      outvct();
      fputc(C_Move, fp);
      fy = highfont ? HiLbtline : Lbtline;
      fx = Lwidth - 2;
      outvct();
      fx = 0;
      outvct();
      fputc(C_Move, fp);
      Yp = highfont ? HiLbtline : Lbtline;
      Xp = 0;
      org_80 = eightypl;
      org_GBmode = GBmode;
      eightypl = TRUE;
      GBmode = 0;
      outtext("ChiRK 1.2a");
      eightypl = org_80;
      GBmode = org_GBmode;
}

/*
 * display a screenful of text( return number of chars written, or utill end
 * of the string( return 0) 
 */

int 
outtext(Pbuf)
      unsigned char  *Pbuf;
{
      int             i = 0, j = 0, k = 0, l, cp = 1, wr = 0, ret = 3, turtle=0;
      unsigned int    quwei;
      unsigned char   chr, chrn, cb1;

      lcwidth = eightypl ? 25 : 34;
      cwidth = eightypl ? 80 : 60;
      while (i < cheight && (chr = Pbuf[k]) != '\0') {
	    chrn = Pbuf[k+1];
	    switch (chr) {
	    case 13:
		  ret = 1;
	    case 10:
		  if (ret == 2) {
			break;
		  }
 		  if( zWon && GBmode) {
			GBmode =0;
			break;
		  }
		  if (autowrap || !wr) {
			Yp -= lfheight;
			Xp = 0;
			i++;
		  }
		  GBmode=0;
		  cp = 1;
		  j = 0;
		  wr = 0;
		  break;
	    case 9:
		  Xp += 8 * lcwidth;
		  j += 8;
		  ret = 0;
		  break;
	    default:
		  if( zWon && ret>=2 && !wr && chr=='z' && chrn=='W'){
			GBmode = 0x80;
			k++;
			break; }
		  ret = 0; 
		  if( chr == '~' && HZon && !turtle && !GBmode ) {
			if( chrn=='{'){
			    GBmode= 0x80;
			    k++;}
			else if( chrn=='~') turtle= TRUE;
			else if( chrn=='\n')
			    k++;
			}
		  else if( HZon && chr == '~' && chrn=='}' && GBmode) {
			GBmode = 0;
			k++; }
		  else if( zWon && chr =='#' && chrn=='\n')  GBmode = 0;
		  else if( zWon && chr =='#' && chrn==' ') {
			Xp += lcwidth;
			j ++;
			k++;
			ret =0; }
		  else{
		      chr |= GBmode;
		      turtle = FALSE;
		      if ( cp < 0 && 
			   (big5 ? (chr>=0x40) :(chr>160)) 
			    && (Pbuf[k-1] |GBmode)> 160
			  || cp>0 && chr > 160 && 
		  	   (big5 ? ((chrn|GBmode)>=0x40) :((chrn|GBmode)>160))){
			if (cp > 0)
			      cb1 = chr;
			else {
			      if (autowrap || !wr) {
				    if (j + 2 > cwidth) {
					  Yp -= lfheight;
					  Xp = 0;
					  if (++i == cheight)
						return (k - 1);
					  wr = 1;
					  j = 0;
				    }
			      }
			      if (autowrap || !wr) {
				    quwei = big5 ? big5order(cb1, chr)
					  : gborder(cb1, chr);
				    (*outchar) (2, quwei);
				    Xp += lcwidth << 1;
				    j += 2;
			      }
			}
			if (!GBmode) cp= -cp;
		    } else {
			if (autowrap || !wr) {
			      if (j + 1 > cwidth) {
				    Yp -= lfheight;
				    Xp = 0;
				    if (++i == cheight)
					  return (k);
				    wr = 1;
				    j = 0;
			      }
			}
			if (autowrap || !wr) {
			      chr &= 0x7f;
			      (*outchar) (1, chr);
			      Xp += lcwidth;
			      j += 1;
			}
		  }
	     if( GBmode) cp= -cp;
	     }
	    }
	    ret++;
	    k++;
      }
      return (chr == '\0' ? 0 : k);
}

int 
showpage(page, Pbuf)
      int             page;
      char           *Pbuf;
{
      char            title[80];
      int             textln, org_80;
      unsigned char   org_GBmode;

      newpage(page);
      Yp = Lheight - 2;
      Xp = 0;
      textln = outtext(Pbuf);
      org_80 = eightypl;
      org_GBmode =GBmode;
      eightypl = TRUE;
      GBmode =0;
      Yp = highfont ? HiLbtline : Lbtline;
      Xp = 0;
      if (interactive) {
	    sprintf(title, "          | Page %d/%d |\0", page, pagenum);
	    outtext(title);
	    if (page < pagenum)
		  outtext(" page forward: nSPACE ");
	    else
		  outtext("                      ");
	    if (page < pagenum || page > 1)
		  outtext("|");
	    if (page > 1)
		  outtext(" page back: nB ");
	    else
		  outtext("               ");
	    outtext("| exit: Q");
      }
      eightypl = org_80;
      GBmode = org_GBmode;
      return (textln);
}

/*
 * big5order - big5 font order 
 */
static unsigned int
big5order(h, l)
      unsigned char   h, l;
{
      register unsigned int charno;

      if (h < 0xA4) {
	    if (l < 0x7F)
		  charno = (h - 0xA1) * 157 + (l - 56);
	    else
		  charno = (h - 0xA1) * 157 + (l - 90);
      } else if(h < 0xC7){
	    if (l < 0x7F)
		  charno = (h - 0xA4) * 157 + (l + 709);
	    else
		  charno = (h - 0xA4) * 157 + (l + 675);
      } else {
	    if( l< 0x7F)
		  charno = (h- 0xA4)*157 + (l + 301);
	     else
		  charno = (h - 0xA4)*157 + (l+267);
	    }

      return (charno > MaxBig5 ? InvalidBig5: charno);
}

/*
 * gborder - gb font order 
 */
unsigned int
gborder(h, l)
      unsigned char   h, l;
{
      register unsigned int charno;

      if (l < 0xa1)		/* GB low should >= 0xa1, make it space */
	    return (InvalidGB);

      if (h > 175)
	    h -= (bitmapfont ? 8 : 6);
      charno = (h - 161) * 94 + (l - 161);

      if( bitmapfont && charno > MaxQuweiB || !bitmapfont && charno > MaxQuweiV)
	     charno = InvalidGB;
      return (charno);
}
