/******************************************************************************
 *
 * VMS NEWS (part NET_DECNET)
 *
 * Copyright 1990 by Bernd Onasch (E-MAIL: ONASCH@ira.uka.de)
 *
 ******************************************************************************
 *
 * DECnet object-Communications
 * ----------------------------------------------------------------------------
 * decnet_send(char *text)
 * decnet_end(int dummy)
 * decnet_start(char *server,char *serverport)
 * decnet_read()
 *
 ******************************************************************************/

#module NET_DECNET "NET V1.24"
#include "header.h"

extern c$dsc(),c$cks(),analyze_line();

/******************************************************************************/

decnet_send(text)
char *text;
{
  unsigned short *i_o_size;

  i_o_size=iosb;
  c$cks(sys$qiow(0,net_chan,IO$_WRITEVBLK,iosb,0,0,text,strlen(text),0,net_chan_tcp,0,0));
  c$cks(*i_o_size);
}

/******************************************************************************/

decnet_end(num)
int num;
{
  do_netexit=TRUE;
  sys$dassgn(net_chan);
}

/******************************************************************************/

decnet_start(server,srvport)
char *server;
char *srvport;
{
  char tmpline[256];
  short *ioptr=iosb;
  extern decnet_read();

  do_netexit=FALSE;
  net_chan_tcp=1;
  sprintf(tmpline,"%s::\"%s\"",server,srvport);
  c$cks(sys$assign(c$dsc(tmpline),&net_chan,0,0));

  c$cks(sys$qio(0,net_chan,IO$_READVBLK|IO$M_MULTIPLE,read_iosb,decnet_read,0,
                outl,NETBUFFER-1,0,0,0,0));
}

/******************************************************************************/

decnet_read()
{
  unsigned short *i_o_size;
  char *cp,*il=outl;
  int bsize=NETBUFFER-1;

  if (!do_netexit) {
    i_o_size=read_iosb; c$cks(*i_o_size);
    nr_pos[*(i_o_size+1)]='\0';

    cp=il;
    while (cp) {
      if (cp=strchr(il,'\n')) *cp=0;
      if ((cp) && (*(cp-1)=='\r')) *(cp-1)=0;
      if (cp) { cp++; analyze_line(il); il=cp; }
    }
    cp=outl;
    while (*cp++ = *il++) --bsize;
    nr_pos=cp-1;
    c$cks(sys$qio(0,net_chan,IO$_READVBLK|IO$M_MULTIPLE,read_iosb,decnet_read,0,
                  nr_pos,bsize,0,0,0,0));
  }
}

/******************************************************************************/
